#!/usr/bin/perl -w
#Program name = LCMALDIprocessor
#Filename = LCMALDIprocessor.pl
#Version 1.0
#RJJ Wed Aug 04 10:11:55 2004
#Copyright KBiosystems 2004

#Description:
#

#Input:
#

#Output:
#

use strict;
use File::Find;
use File::Basename;
use XML::Simple;
use Win32::FileOp qw(BrowseForFolder);
use Tk;
use Tk::Carp qw(warningsToDialog fatalsToDialog);
require Tk::ActivityBar;


#Read in data sets into an array of arrays
#GUI variables
my (
	$Main,
	$lbPlate,
	$Label2, 
	$Label3, 
	$Label4,
	$Label5,
	$Label6,
	$Label7,
	$Label12,
	$Label9, 
	$Label10,
	$Label11,
	$lbNoMS,
	$lbNoMSMS,
	$btDataDir,
	$rbDirection1,
	$rbDirection2,
	$edTolValue,
	$rbTolerance1,
	$rbTolerance2,
	$edCCCutOff, 
	$rb2Dtolerance1,
	$rb2DTolerance2,
	$ed2DTolValue, 
	$edLower,
	$edUpper,
	$btProcesses,
	$btAbout,
	$btExit,
	$edPath,
	$progressbar
);

#global variables
my (
	$toleranceValue,
	$toleranceType,
	$twoDtoleranceValue,
	$twoDtoleranceType,
	$startingFolder,
	$lower_mass,
    $endmass,
	$percent,
	$plateDirection,
	@Filename_list,
	$NoMSlable,
	$NoMSMSlable,
	$percent_done,
);

my $perlversion = $^O;
#print $perlversion;
if ($perlversion eq "MSWin32"){
	use Win32::FileOp qw(ShellExecute);
}

$Main = MainWindow->new;
$Main->title("LCMALDI processor");
$Main->geometry("441x238+8+8");
$lbPlate = $Main->Label(
                        -text => "Plate direction", 
                        -background => "#D4D0C8", 
                        -cursor => "", 
                        -font => "Tahoma 8 normal"
                        );


$lbPlate->place(-width => 79, 
                -height => 13, 
                -x => 26, 
                -y => 56);

$Label2 = $Main->Label(
                       -text => "Common Contaminant settings", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label2->place(-width => 151, 
               -height => 13, 
               -x => 45, 
               -y => 96);

$Label3 = $Main->Label(
                       -text => "Tolerance Value", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label3->place(-width => 87, 
               -height => 13, 
               -x => 24, 
               -y => 120);

$Label4 = $Main->Label(
                       -text => "Tolerance Type", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label4->place(-width => 79, 
               -height => 13, 
               -x => 25, 
               -y => 152);

$Label5 = $Main->Label(
                       -text => "Common contamint cutoff", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label5->place(-width => 135, 
               -height => 13, 
               -x => 24, 
               -y => 184);

$Label6 = $Main->Label(
                       -text => "%", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label6->place(-width => 31, 
               -height => 13, 
               -x => 208, 
               -y => 184);

$Label7 = $Main->Label(
                       -text => "2D LCMS array settings", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label7->place(-width => 135, 
               -height => 13, 
               -x => 285, 
               -y => 32);

$Label3 = $Main->Label(
                       -text => "Tolerance Value", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label3->place(-width => 87, 
               -height => 13, 
               -x => 264, 
               -y => 56);

$Label9 = $Main->Label(
                       -text => "Tolerance Type", 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$Label9->place(-width => 79, 
               -height => 13, 
               -x => 267, 
               -y => 88);

$Label10 = $Main->Label(
                        -text => "Lower Mass", 
                        -background => "#D4D0C8", 
                        -cursor => "", 
                        -font => "Tahoma 8 normal"
                        );


$Label10->place(-width => 79, 
                -height => 13, 
                -x => 260, 
                -y => 120);

$Label11 = $Main->Label(
                        -text => "Upper Mass", 
                        -background => "#D4D0C8", 
                        -cursor => "", 
                        -font => "Tahoma 8 normal"
                        );


$Label11->place(-width => 71, 
                -height => 13, 
                -x => 262, 
                -y => 144);

$lbNoMS = $Main->Label(
                       -textvariable => \$NoMSlable, 
                       -background => "#D4D0C8", 
                       -cursor => "", 
                       -font => "Tahoma 8 normal"
                       );


$lbNoMS->place(-width => 103, 
               -height => 13, 
               -x => 258, 
               -y => 176);

$lbNoMSMS = $Main->Label(
                         -textvariable => \$NoMSMSlable,  
                         -background => "#D4D0C8", 
                         -cursor => "", 
                         -font => "Tahoma 8 normal"
                         );


$lbNoMSMS->place(-width => 119, 
                 -height => 13, 
                 -x => 259, 
                 -y => 192);

$btDataDir = $Main->Button(
                           -text => "Data Directory", 
                           -cursor => "", 
                           -font => "Tahoma 8 normal",
						   -command => \&selectFolder
                           );


$btDataDir->place(-width => 88, 
                  -height => 24, 
                  -x => 24, 
                  -y => 8);

$rbDirection1 = $Main->Radiobutton(
					-text => "Forward",
					-value => "Forward",
					-variable => \$plateDirection,
                                  );


$rbDirection1->place(-width => 65, 
                    -height => 17, 
                    -x => 120, 
                    -y => 48);

$rbDirection2 = $Main->Radiobutton(
					-text => "Backward",
					-value => "Backward",
					-variable => \$plateDirection
					);


$rbDirection2->place(-width => 70, 
                    -height => 17, 
                    -x => 123, 
                    -y => 64);

$edTolValue = $Main->Entry(
                           -cursor => "", 
                           -font => "Tahoma 8 normal",
						   -textvariable => \$toleranceValue,
                           );


$edTolValue->place(-width => 25, 
                   -height => 21, 
                   -x => 168, 
                   -y => 120);

$rbTolerance1 = $Main->Radiobutton(
					-text => "ppm",
					-value => "ppm",
					-variable => \$toleranceType,
                    );


$rbTolerance1->place(-width => 57, 
               -height => 17, 
               -x => 157, 
               -y => 144);

$rbTolerance2 = $Main->Radiobutton(
					-text => "Da",
					-value => "Da",
					-variable => \$toleranceType,
                    );


$rbTolerance2->place(-width => 40, 
                    -height => 17, 
                    -x => 163, 
                    -y => 160);

$edCCCutOff = $Main->Entry(
                           -cursor => "", 
                           -font => "Tahoma 8 normal",
						   -textvariable => \$percent,
                           );


$edCCCutOff->place(-width => 33, 
                   -height => 21, 
                   -x => 168, 
                   -y => 184);

$rb2Dtolerance1 = $Main->Radiobutton(
					-text => "ppm",
					-value => "ppm",
					-variable => \$twoDtoleranceType,
                    );


$rb2Dtolerance1->place(-width => 57, 
                      -height => 17, 
                      -x => 350, 
                      -y => 80);

$rb2DTolerance2 = $Main->Radiobutton(
					-text => "Da",
					-value => "Da",
					-variable => \$twoDtoleranceType,
                    );


$rb2DTolerance2->place(-width => 57, 
                      -height => 17, 
                      -x => 347, 
                      -y => 96);

$ed2DTolValue = $Main->Entry(
                             -cursor => "", 
                             -font => "Tahoma 8 normal",
							 -textvariable => \$twoDtoleranceValue,
                             );


$ed2DTolValue->place(-width => 33, 
                     -height => 21, 
                     -x => 360, 
                     -y => 56);

$edLower = $Main->Entry(
                        -cursor => "", 
                        -font => "Tahoma 8 normal",
						-textvariable => \$lower_mass,
                        );


$edLower->place(-width => 57, 
                -height => 21, 
                -x => 360, 
                -y => 112);

$edUpper = $Main->Entry(
                        -cursor => "", 
                        -font => "Tahoma 8 normal",
						-textvariable => \$endmass,
                        );


$edUpper->place(-width => 57, 
                -height => 21, 
                -x => 360, 
                -y => 144);

$btProcesses = $Main->Button(
                             -text => "Process data", 
                             -cursor => "", 
                             -font => "Tahoma 8 normal",
							 -command => \&processData
                             );


$btProcesses->place(-width => 96, 
                    -height => 24, 
                    -x => 24, 
                    -y => 208);

$btExit = $Main->Button(
                        -text => "Exit", 
                        -cursor => "", 
                        -font => "Tahoma 8 normal",
						-command => \&quitProgram
                        );


$btExit->place(-width => 59, 
               -height => 25, 
               -x => 360, 
               -y => 208);

$btAbout = $Main->Button(
						 -command => \&about,
                         -text => "About", 
                         -cursor => "", 
                         -font => "Tahoma 8 normal"
                         );


$btAbout->place(-width => 59, 
                -height => 25, 
                -x => 295, 
                -y => 208);

$edPath = $Main->Entry(
                       -cursor => "", 
                       -font => "Tahoma 8 normal",
					   -textvariable => \$startingFolder,
                       );


$edPath->place(-width => 121, 
               -height => 21, 
               -x => 120, 
               -y => 8);

$progressbar = $Main->ActivityBar(
        -width => 164,
        -length => 20,
		-interval=> 10,
    );
$progressbar->place(-width => 164, 
              -height => 20, 
              -x => 125, 
              -y => 210);

#set variables to defaults
$twoDtoleranceValue = "1"; # for binned 2D LCMS array
$twoDtoleranceType = "Da"; # for binned 2D LCMS array
$lower_mass = "0"; # for binned 2D LCMS array
$endmass = "4000"; # for binned 2D LCMS array
$plateDirection = "Forward"; #"Forward" or "Backward" - depends on the robot (Exon robot currently "Backward")
#commoncontam parameters
$toleranceValue = 250;
$toleranceType = "ppm";
$percent = 10;
$NoMSlable = "Number of MS: 0";
$NoMSMSlable = "Number of MS/MS: 0";
$percent_done = 0;

MainLoop;

############################ SUBS ###########################
#######################
#processData Subroutine
#Richard Jacob
#Copyright (c) 2004 KBiosystems
#
#Description
#
#
#######################
sub processData {
	my (
		$file,
		$filecount,
		$currentfile,
		$totalNoMasses,
		$totalNoMassesText,
		$removeValue,
		@allmasses_list,
		@allmasses_list_clean,
		%massFiles,
		$templist,
		@tempfilelist,
		@masslist1,
		@masslist2,
		$mass1,
		$mass2,
		%masslist1_hits,
		%fileName_NoArray,
		$outfile,
		$outfile_count,
		$outfile_graph,
		$outfile_peakcount,
		@removemass_array,
		$fileNo,
		$base,
		$path,
		$type,
		%dataArray,
		$MassIntensityArray,
		$expName,
		$expType,
		$expSpot,
		$outputfile,
		$outfile_bpi,
		@directory_split,
		$fileset_count,
		@TempArray,
		$Average,
		$StdDev,
		%parameters,
		$parention,
		%liftArray,
		$peakoutfile,
		%masslist2_hits,
		$AllMassoutfile,
		%filenamematrix,
		$AllMassoutfile_clean,
		%removeFromFile,
		$ExcludeListOut,
		$AllMassoutfile_exclude,
		$time,
		%filenamematrix_process,
		$BinnedMatrix,
		@mass_matrix_list,
		$twoD_out,
		@twoD_masses,
		$parentionInt,
		$NoPeaks,
		$NoSpectra,
		$NoLIFT,
		$tempCounter,
		@sortedIntensities,
		$cutoff_factor,
		$numberOfFiles,
		$counter,
	);
	$progressbar->startActivity();
	$Main->update;
	#Set starting folder and user defined parameters
	@directory_split = split (/\\/, $startingFolder);
	$outputfile = $startingFolder . "\\" . $directory_split[-1] . ".xls";
	$outfile = $startingFolder . "\\" ."CommonMasses_" . $directory_split[-1];
	$AllMassoutfile = $startingFolder . "\\" ."AllMasses_" . $directory_split[-1] .".txt";
	$AllMassoutfile_clean = $startingFolder . "\\" ."AllMasses_clean_" . $directory_split[-1] .".txt";
	$ExcludeListOut = $startingFolder . "\\" ."Exclude_list_" . $directory_split[-1] .".txt";
	$AllMassoutfile_exclude = $startingFolder . "\\" ."AllMasses_exclude_" . $directory_split[-1] .".txt";
	$twoD_out = $startingFolder . "\\" ."2D-matrix_" . $directory_split[-1] . ".txt";
	$outfile_count = $startingFolder . "\\" ."count_" . $directory_split[-1] . ".xls";
	$outfile_graph = $startingFolder . "\\" ."graph_" . $directory_split[-1] . ".xls";
	$outfile_bpi = $startingFolder . "\\" ."bpi_" . $directory_split[-1] . ".xls";
	$outfile_peakcount = $startingFolder . "\\" ."peakcount_" . $directory_split[-1] . ".xls";
	#$Worksheet_outfile = "Worksheet" . $directory_split[-1] . ".txt";
	
	$NoSpectra = 0;
	$NoLIFT = 0;
	#find peaklist.xml files
	print "Finding peaklist files\n";
	find(\&findxml, $startingFolder);
	#generate an array of xml files and the all masses list
	print "Extracting data\n";
	$counter =0;
	$numberOfFiles = $#Filename_list;
	foreach $currentfile (@Filename_list){
		$counter ++;
		$percent_done = ($counter/$numberOfFiles)*100;
		$progressbar->configure('-value' => $percent_done);
		$Main->update;
		($MassIntensityArray,$expName, $expType, $expSpot) = &extractdata ($currentfile);
		if ($expType eq "MS"){
			#determine bpi for spectra and place it in the data array
			#sort the keys of the mass intensity array by the intensity (values) and grab the largest value
			if (keys (%{$MassIntensityArray})){
				@sortedIntensities = sort {$a <=> $b}(values (%{$MassIntensityArray}));
				if (@sortedIntensities>0){
					$dataArray{$expName}->[5] = $sortedIntensities[-1];
				}
			}
			else {
				$dataArray{$expName}->[5] = 0;
			}
			#copm new mass list into allmasses master list
			@allmasses_list  = (@allmasses_list, (keys %{$MassIntensityArray}));
			$dataArray{$expName}->[0] = $MassIntensityArray;
			($BinnedMatrix) =  BinMass ($MassIntensityArray, $twoDtoleranceType, $twoDtoleranceValue, $lower_mass, $endmass);
			#add file_matrix to list of matrixes
			push (@mass_matrix_list, $BinnedMatrix);
			$NoSpectra ++;
	
		}
		else{
			($parention) = ($expName =~ /(\d+\.\d+)/);
			($parentionInt) = ($parention =~ /(\d+)\.\d+/);
			$dataArray{$expSpot}->[4]->{$parentionInt} =  $parention;
			$NoLIFT ++;
			#push (@{$liftArray{$expSpot}}, $parention );
		}
	}
	$progressbar->startActivity();
	$Main->update;
	#set gui labels
	$NoMSlable = "Number of MS: $NoSpectra";
	$NoMSMSlable = "Number of MS/MS: $NoLIFT";
	
	@tempfilelist = sort (keys %dataArray);
	(%filenamematrix) = renumber_filenames (@tempfilelist);
	#foreach file
	foreach $currentfile (@tempfilelist){
		$dataArray{$currentfile}->[1] = $filenamematrix{$currentfile};
	}
	
	#remove duplicates from allmass list
	print "Sorting all mass list and removing duplicates\n";
	@allmasses_list = sort {$a <=> $b}(@allmasses_list);
	(@allmasses_list_clean) = &remove_duplicates (@allmasses_list, $toleranceType, $toleranceValue);
	#Sort all masses list
	@allmasses_list = sort {$a <=> $b}(@allmasses_list);
	@allmasses_list_clean = sort {$a <=> $b}(@allmasses_list_clean);
	open (ALLMASSES, ">$AllMassoutfile");
	foreach $mass1 (@allmasses_list){
		print ALLMASSES "$mass1\n";
	}
	close ALLMASSES;
	open (ALLMASSES, ">$AllMassoutfile_clean");
	foreach $mass1 (@allmasses_list_clean){
		print ALLMASSES "$mass1\n";
	}
	close ALLMASSES;
	@masslist1 = @allmasses_list_clean;
	
	$numberOfFiles = $#tempfilelist;
	$counter =0;
	print "Grouping masses\n";
	foreach $templist (@tempfilelist){
		$counter ++;
		$percent_done = ($counter/$numberOfFiles)*100;
		$progressbar->configure('-value' => $percent_done);
		$Main->update;
		
		#$fileNo ++;
		#$fileName_NoArray{$fileNo} = $templist;
		#set mass list 2 to the masses for the filename from data array
		@masslist2 = (keys %{$dataArray{$templist}->[0]});
		@masslist2 = sort {$a <=> $b}(@masslist2);
		foreach $mass1 (@masslist1) {
			#set mass1 tolerance
			my $current_tolerance = cal_mass_tolerance ($mass1, $toleranceType, $toleranceValue );
			#foreach mass2 from list 2
			foreach $mass2 (@masslist2){	
				if ($mass2 > $mass1 + $current_tolerance){
					#mass to high
					last;
				}
				elsif ($mass2 < $mass1 - $current_tolerance){
					#mass to low	
					next;
				}
				else {
					#mass is a match place into a hash of hashes indexed with common mass then file name
					$dataArray{$templist}->[2]->{$mass2} =  "1";
					#$masslist1_hits{$mass1}->{$templist}= $dataArray{$templist}{$mass2};
					push (@{$masslist1_hits{$mass1}}, $templist);
				}
			}
		}
	}
	$progressbar->startActivity();
	$Main->update;
	
	open (OUTFILECOUNT, ">$outfile_count");
	print OUTFILECOUNT "Count_Mass\tCount_Count\n";
	#my @countTemp;
	foreach $mass1 (@allmasses_list_clean){
		#print "$#{$masslist1_hits{$tempmass}}\n";
		my $tempcount = $#{$masslist1_hits{$mass1}};
		$tempcount ++;
		print OUTFILECOUNT "$mass1\t$tempcount\n";
		#push (@countTemp, $tempcount);
	}
	close OUTFILECOUNT;
	
	#foreach $mass1 (@allmasses_list){
	#	for (my $i= 1; $i <$tempcount; $i++){
	#			print OUTFILEGRAPH "$masslist1_hits{$mass1}->[$i]\t$mass1\t$dataArray{$masslist1_hits{$mass1}->[$i]}->[1]\t$dataArray{$masslist1_hits{$mass1}->[$i]}->[0]->{$mass1}\n";
	#		}
	#}
	
	#@countTemp = sort {$a <=> $b} (@countTemp);
	#$totalNoMasses = pop(@countTemp);
	
	$counter =0;
	$filecount = $#tempfilelist;
	$cutoff_factor = $percent/100;
	$removeValue = $filecount * $cutoff_factor;
	
	foreach my $tempmass (@allmasses_list_clean){
		if ( $removeValue <= $#{$masslist1_hits{$tempmass}}){
			#add to remove list
			push (@removemass_array, $tempmass);
		}
	}
	#foreach file
	foreach $templist (@tempfilelist){
		$counter ++;
		$percent_done = ($counter/$filecount)*100;
		$progressbar->configure('-value' => $percent_done);
		$Main->update;
		#foreach removemass
		@masslist1 = sort {$a <=> $b} (@removemass_array);
		@masslist2 = (keys %{$dataArray{$templist}->[0]});
		@masslist2 = sort {$a <=> $b}(@masslist2);
		foreach $mass1 (@masslist1) {
			#set massA tolerance
			my $current_tolerance = cal_mass_tolerance ($mass1, $toleranceType, $toleranceValue );
			#foreach massB in list 2
			foreach $mass2 (@masslist2){	
				if ($mass2 > $mass1 + $current_tolerance){
					#mass to high
					last;
				}
				elsif ($mass2 < $mass1 - $current_tolerance){
					#mass to low	
					next;
				}
				else {
					#mass is a match
					#count No times each mass in all mass list occures in mass lists
					$dataArray{$templist}->[3]->{$mass2}= 1;
					#$removeFromFile{$mass2} = 1;
				}
			}
		}
	}
	$progressbar->startActivity();
	$Main->update;
	#print printmass array to file
	open (EXCLUDE, ">$ExcludeListOut");
	%filenamematrix_process = reverse %filenamematrix;
	
	foreach $templist (sort {$a <=> $b}(keys %filenamematrix_process)){
		@masslist1 = (keys %{$dataArray{$filenamematrix_process{$templist}}->[3]});
		@masslist1 = sort {$a <=> $b}(@masslist1);
		foreach $mass1 (@allmasses_list_clean){
			if ($removeFromFile{$mass1}){
				push (@masslist1, $mass1);
			}
		}	
	}
	#(@masslist1) = &remove_duplicates (@masslist1, $toleranceType, $toleranceValue);
	#(@masslist2) = &remove_duplicates (@masslist2, $toleranceType, $toleranceValue);
	
	foreach $mass1 (@removemass_array){
		print EXCLUDE "$mass1\n";
	}
	close EXCLUDE;
	
	  
	#open the output file
	print "Generating output files\n";
	open (ALLEXCLUDE, ">$AllMassoutfile_exclude");
	open (OUTFILE,">$outputfile" )|| die "cant make results file\n";
	open (OUTPEAKS,">$outfile_peakcount" )|| die "cant make results file\n";
	open (OUTFILEGRAPH, ">$outfile_graph");
	open (OUTBPI, ">$outfile_bpi");
	
	#print the file headers
	print OUTFILE "Experiment name\t$directory_split[-1]\n";
	print OUTFILE "Tolerance\t$toleranceValue\t$toleranceType\n";
	print OUTFILE "Cut of value for excluded peptides set to:\t$removeValue\n";
	print OUTFILE "Number of MS spectra:\t$NoSpectra\n";
	print OUTFILE "Number of LIFT spectra:\t$NoLIFT\n";
	
	
	$tempCounter = $#allmasses_list;
	$tempCounter ++;
	print OUTFILE "Number of peptides:\t$tempCounter\n";
	$tempCounter = $#allmasses_list_clean;
	$tempCounter ++;
	print OUTFILE "Number of unique peptides:\t$tempCounter\n";
	
	#print OUTFILE "Number of excluded peptides:\t$tempCounter\n";
	$tempCounter = $#removemass_array;
	$tempCounter ++;
	print OUTFILE "Number of unique excluded peptides:\t$tempCounter\n";
	
	print OUTFILE "Database searched:\t\n\n\n";
	print OUTFILE "Protein\tNo. peptides ID\n\n\n\n";
	print OUTFILE "Unassigned/undetermined\t0\n\n\n";
	print OUTFILE "Mass\tSpot Name\tSpot No\tTime\tStatus\tLIFT\tParent ion\tID\tSequence\tAccession No\n";
	print OUTPEAKS "NoPeaks_FractionNumber\tNoPeaks_NoPeaks\n";
	print OUTFILEGRAPH "Spot\tMass\tFractionNumber\tIntensity\n";
	print OUTBPI "BPI_FractionNumber\tBPI_Intensity\n";
	
	$counter =0;
	%filenamematrix_process = reverse %filenamematrix;
	foreach $templist (sort {$a <=> $b} (keys %filenamematrix_process)){
		$counter ++;
		$percent_done = ($counter/$numberOfFiles)*100;
		$progressbar->configure('-value' => $percent_done);
		$Main->update;
		@masslist1 = (keys %{$dataArray{$filenamematrix_process{$templist}}->[0]});
		@masslist1 = sort {$a <=> $b}(@masslist1);
		$NoPeaks = $#masslist1;
		$NoPeaks ++;
		print OUTPEAKS "$templist\t$NoPeaks\n";
		if ($dataArray{$filenamematrix_process{$templist}}->[5]){
			print OUTBPI "$templist\t$dataArray{$filenamematrix_process{$templist}}->[5]\n";
		}
		else {
			print OUTBPI "$templist\t0\n";
		}
		$time = ($templist * 0.5) + 7;
		foreach $mass1 (@masslist1){
			print OUTFILE "$mass1\t$filenamematrix_process{$templist}\t$templist\t$time\t";
			print OUTFILEGRAPH "$filenamematrix_process{$templist}\t$mass1\t$templist\t$dataArray{$filenamematrix_process{$templist}}->[0]->{$mass1}\n";
			if ($dataArray{$filenamematrix_process{$templist}}->[3]{$mass1}){
				print OUTFILE "Exclude\t";
				print ALLEXCLUDE "$filenamematrix_process{$templist}\t$mass1\n";
			}
			else {
				print OUTFILE "Clean\t";
			}
			($parentionInt) = ($mass1=~ /(\d+)\./);
			if ($dataArray{$filenamematrix_process{$templist}}->[4]->{$parentionInt}){
				#$liftArray{$filenamematrix_process{$templist}}{$mass1}){
				print OUTFILE "LIFT\t" . $dataArray{$filenamematrix_process{$templist}}->[4]->{$parentionInt} . "\t";
			}
			else {
				print OUTFILE "\t\t";
			}
			print OUTFILE "\n";
		}
	}
	$progressbar->startActivity();
	$Main->update;
	close ALLEXCLUDE;
	close OUTFILEGRAPH;
	close OUTBPI;
	close OUTPEAKS;
	print OUTFILE "\n";
	close OUTFILE;
	
	#open output file
	open (OUTPUT, ">$twoD_out")|| die "can't open output file";
	#sort all_masses list
	@twoD_masses = (0...4000);
	#print tab (\t)
	print OUTPUT "\t";
	#for each mass in all_masses
	foreach $mass1 (@twoD_masses) {
		#print mass \t
		print OUTPUT "$mass1\t";
	}
	print OUTPUT "\n";
	#$section_count 
	#for each section in section list
	$counter =0;
	my $z= $#mass_matrix_list;
	foreach $templist (sort {$a <=> $b}(keys %filenamematrix_process)){
		$counter ++;
		$percent_done = ($counter/$numberOfFiles)*100;
		$progressbar->configure('-value' => $percent_done);
		$Main->update;
		#print $section_count \t
		print OUTPUT "$templist\t";
		#for each mass in all_masses
		foreach $mass1 (@twoD_masses) {
			if (exists($mass_matrix_list[$z]{$mass1})){
				#print value \t
				print OUTPUT "$mass_matrix_list[$z]{$mass1}\t";
			}
			else {
				#else print 0 \t
				print OUTPUT "0\t";
			}
		}
		print OUTPUT "\n";
		$z --;
		unless ($z >0){
			last;
		}
	}
	#close output file
	close(OUTPUT) || die "Couldn't close output file!\n";
	$percent_done = 100;
	$progressbar->configure('-value' => $percent_done);
	$Main->update;
	#print "Done!\n";	
	return ();
}
#######################
#quitProgram Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Exit program
#
#######################
sub quitProgram {
		exit;
}
#######################
#selectFolder Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Select a folder using the windows GUI browser
#
#######################
sub selectFolder {
	my $types = [['Text Files',['.txt']]];
	my $title = 'Select Starting folder';
	my $rootFolder = "CSIDL_RECENT";
	($startingFolder) = BrowseForFolder ['test'];
	return ();
}
#######################
#findxml Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Uses the File::Find module to recursively locate all the txt files 
#
#######################
sub findxml {
	# get all file names that have last 3 characters "xml"
	my ( $filename_temp);
	if($File::Find::name=~/\.xml$/){
		# read in xml file
		$filename_temp = $File::Find::name;
		push (@Filename_list, $filename_temp);
		return ();
	}
    else {
        return ();
    }
}

#######################
#extractdata Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Extracts the mass, intensity and base file name from a file.
#
#######################
sub extractdata {
	my ($filename) = @_;
    my (
        $massListObj,
        @filename_split,
        $splitposition,
        $currentSample,
        $expType,
        $expName,
        $expSpot,
        %filenameArray,
        %MassInstArray
    );
    #readin xml
	@filename_split = split (/\//, $filename);
    if ($filename_split[-5]=~/LIFT/){
        $expType = "LIFT";
        $expName = $filename_split[-5];
        $expSpot = $filename_split[-7];
    }
    else {
        $expType = "MS";
        $expName = $filename_split[-6];
        $expSpot = $expName;
        $massListObj= XMLin("$filename", forcearray => 1) or die "could not open file - $_ - : $!";
        #does the xml file contain some peaks?
        unless (defined $massListObj->{'pk'}){
            return (\%MassInstArray, $expName, $expType, $expSpot);
        }
        #grab the peak info array from the xml file
        my @peaks = @{$massListObj->{'pk'}};
        my $totalpeaks = $#peaks;
        #foreach peak
        for (my $peakcount = 0; $peakcount <= $totalpeaks; $peakcount ++){
            #place mass and intensity into array
            $MassInstArray{$peaks[$peakcount]->{'mass'}->[0]} =$peaks[$peakcount]->{'absi'}->[0];
        }
        
    }
    #return mass and intensity array and filename
	return (\%MassInstArray, $expName, $expType, $expSpot);
}

#######################
#remove_duplicates Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Removes all the duplicate masses within a defined error from a list of masses.
#Needs some refinement so that it does not work on the lowest mass but selects 
#the midle mass in a group.
#
#######################
sub remove_duplicates {
	my @variables = @_;
	my $tolerance_value = pop (@variables);
	my $tolerance_type = pop (@variables);
	my @masslist = @variables;
	my @found_duplist = ();
	my @no_duplist = ();
	my @duplist = @masslist;
	foreach my $currmass (@masslist){
		#for each current mass calculat the tolerance
		my $current_tolerance = cal_mass_tolerance ($currmass, $tolerance_type, $tolerance_value );
		#initilise duplicate list
		#set duplist2 to duplist minius the curent mass (postion 0)
		my $trash = shift (@duplist);
		my $found_dups = 0;
		#compare to privious known duplicate masses
		my $found_privious = 0;
		foreach my $item (@found_duplist){
			 if($item == $currmass){
			 	$found_privious= 1;
			 	last;
			}
		}
		unless ($found_privious ==0){
			next;
		}
		if ($currmass eq "\n"){
			push (@found_duplist, $currmass);
			next;
		}
		if ($currmass !~ /^\d+/){
			push (@found_duplist, $currmass);
			next;
		}
		foreach my $dupmass (@duplist){
			#compare to tolerance
			if ($dupmass > $currmass + $current_tolerance){
				#mass to high
				last;
			}
			elsif ($dupmass < $currmass - $current_tolerance){
				#mass to low	
				next;
			}
			else {
				#mass is a duplicate
				my $found_dups = 1;
				push (@found_duplist, $dupmass);
			}
		}
		if ($found_dups == 0){
		push (@no_duplist, $currmass);
		}
	}
	return (@no_duplist);
}

#######################
#cal_mass_tolerance Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Calculates the mass error value.
#mmu not yet supported
#
#######################
sub cal_mass_tolerance {
	my $mass = $_[0];
	my $tolerance_type = $_[1];
	my $tolerance_value = $_[2];
	my $mass_tolarance = 0;
	if ($tolerance_type eq "ppm"){
		#calculate mass tolerance in ppm
		$mass_tolarance = (($tolerance_value/1e6) * $mass);
	}
	#if tolerance eq Da	
	elsif ($tolerance_type  eq "Da"){
		#use tolerance value 
		$mass_tolarance = $tolerance_value;
	}
	#if tolerance eq mmu	
	elsif ($tolerance_type  eq "mmu"){
		#calculate mass tolerance in mmu 
		$mass_tolarance = $tolerance_value/1000;
	}
	return $mass_tolarance;
}
#######################
#renumber_filenames Subroutine
#Richard Jacob
#Copyright (c) 2004 KBiosystems
#
#Description
#
#
#######################
sub renumber_filenames {
    my (
        @files_to_process,
        $filename,
        $start,
		$stop,
        $index,
        @letters,
        @numbers,
        $letter,
        $number,
        $tempFilename,
        %filenamematrix,
        @filenamelist,
        $flag,
        $newname,
        $startnumber,
        $startletter,
		$stopletter,
		$stopnumber,
		@filenameLetters,
		@filenameNumbers
    );
    @files_to_process = @_;
    $index = 1;
    #create comparision matrix
    @letters = qw(A B C D E F G H I J K L M N O P);
    @numbers = (1 .. 24);
	
	#need to put in flag controll of the direction!
	if ($plateDirection eq "Backward"){
		@letters = reverse @letters;
		@numbers = reverse @numbers;
	}
	
    $flag = 0;
    #build tempfilename array 
    foreach $letter (@letters){
        foreach $number (@numbers){
            $tempFilename = "0_" . $letter . $number;
            $filenamematrix{$tempFilename} = 0;
            push (@filenamelist, $tempFilename);
        }
    }
    #find start
	foreach $filename (@files_to_process) {
		push (@filenameLetters, ($filename =~/0_(\w)/));
	}
	@filenameLetters = sort @filenameLetters;
	#depends on the direction
	if ($plateDirection eq "Forward"){
		$startletter =	shift (@filenameLetters);
		$stopletter =	pop (@filenameLetters);
	}
	else{
		$startletter =	pop (@filenameLetters);
		$stopletter =	shift (@filenameLetters);
	}
	
	foreach $filename (@files_to_process) {
		push (@filenameNumbers, ($filename =~/0_$startletter(\d+)/));
	}
	@filenameNumbers = sort {$a <=> $b} @filenameNumbers;
	if ($plateDirection eq "Forward"){
		$startnumber =	shift (@filenameNumbers);
	}
	else {
		$startnumber =	pop (@filenameNumbers);
	}
	foreach $filename (@files_to_process) {
		push (@filenameNumbers, ($filename =~/0_$stopletter(\d+)/));
	}
	@filenameNumbers = sort {$a <=> $b} @filenameNumbers;
	if ($plateDirection eq "Forward"){
		$stopnumber = pop (@filenameNumbers);
	}
	else{
		$stopnumber = shift (@filenameNumbers);
	}
	$start = "0_".$startletter .$startnumber;
	$stop = "0_".$stopletter .$stopnumber;
    foreach $tempFilename (@filenamelist){
        if ($tempFilename eq $start){
            $flag = 1;
        }
        if ($flag == 1){
            $filenamematrix{$tempFilename} = $index;
            $index ++;
			if ($tempFilename eq $stop){
				last;
			}
        }
    }
	return (%filenamematrix);
}

#######################
#BinMass Subroutine
#Richard Jacob
#Copyright (c) 2004 KBiosystems
#
#Description
#
#
#######################
sub BinMass {
	#Input
	#input Filename 
	my ($MassInstHashRef, $tolerance_type, $tolerance_value, $lower_mass, $endmass) = @_;
	my (@mass_array,$line, $newfilename, @filesplit, %MassInstHash, %MassInstHash_Binned);
	%MassInstHash = %{$MassInstHashRef};
	@mass_array = sort {$a <=> $b}(keys (%MassInstHash));

	my ($upper_mass, $graph_value, $mass_window, $bin, $i, $mass_out, $mass, $unique_percent);
	while ($lower_mass <$endmass){
		$mass_window = cal_mass_tolerance ($lower_mass, $tolerance_type, $tolerance_value );
		$upper_mass = $lower_mass + $mass_window;
		$graph_value = $lower_mass;
		$bin =0;
		#print "mass win is $mass_window upper $upper_mass lower $lower_mass graph $graph_value\n";
		foreach $mass_out (@mass_array){
			if ($mass_out >= $lower_mass){
				if ($mass_out < $upper_mass){
					$MassInstHash_Binned{$graph_value} = $MassInstHash{$mass_out};
					$bin =1;
					last;
					#print "We got a hit mass $mass_out lower $lower_mass upper $upper_mass bin $bin\n";
				}
			}
		}
		if ($bin ==0){
			$MassInstHash_Binned{$graph_value} = 0;
		}
		$lower_mass = $upper_mass;
	}
	#close (OUTBIN) || die "Couldn't close output file file!\n";
	return (\%MassInstHash_Binned);
}
#######################
#about Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#Opens "About" window with www link to KBiosystems
#
#######################
sub about {
	my $Form1 = MainWindow->new;
	$Form1->title("UltraMassList - About");
	$Form1->geometry("450x350+8+8");
	my $Label1 = $Form1->Label(
							-text => "UltraSamplePlate\n Version 1.0", 
							-background => "#D4D0C8", 
							-cursor => "", 
							-font => "Tahoma 14 bold"
							);
	$Label1->place(-width => 232, 
				   -height => 56, 
				   -x => 170, 
				   -y => 50);
	
	my $logokb = $Form1->Photo(-file=> "KBiosystemsLogo.gif");
	my $btLogokb = $Form1->Button(
                          -image => $logokb,
                          -command => sub { gologo("kb");},
                          -cursor => ""
                          );

	$btLogokb->place(-width => 59, 
                -height => 100, 
                -x => 4, 
                -y => 10);
	
	my $logoLudwig = $Form1->Photo(-file=> "LICRlogo.gif");
	my $btLogoLudwig = $Form1->Button(
                          -image => $logoLudwig,
                          -command => sub{gologo("Ludwig"),},
                          -cursor => ""
                          );

	$btLogoLudwig->place(-width => 96, 
                -height => 98, 
                -x => 4, 
                -y => 115);
	
	my $logoUCL = $Form1->Photo(-file=> "UCLlogo.gif");
	my $btLogoUCL = $Form1->Button(
                          -image => $logoUCL,
                          -command => sub{&gologo("UCL"),},
                          -cursor => ""
                          );

	$btLogoUCL->place(-width => 93, 
                -height => 111, 
                -x => 4, 
                -y => 220);

	my $Label2 = $Form1->Label(
							-text => "UltraSamplePlate generates sample tables to \nanalyse LCMALDI runs for use with the Bruker Ultraflex.\nThe software supports CalibAnchors, 96 additional anchors\nfor external calibration or a defined calibration row.\n\nBy Richard Jacob.\nCopyright (2004) KBiosysytems.\nAll rights reserved.", 
							-background => "#D4D0C8", 
							-cursor => "", 
							-font => "Tahoma 10 normal"
							);
	$Label2->place(-width => 350, 
				   -height => 200, 
				   -x => 100, 
				   -y => 115);

	my $Label3 = $Form1->Label(
							-text => "Email\: r.jacob\@ucl.ac.uk with questions and bug reports.", 
							-background => "#D4D0C8", 
							-cursor => "", 
							-font => "Tahoma 8 normal"
							);

	$Label3->place(-width => 300, 
				   -height => 30, 
				   -x => 100, 
				   -y => 300);
	return ();
}

#######################
#gologo Subroutine
#Richard Jacob
#Copyright (c) 2003 KBiosystems
#
#Description
#opens the logos  webpage
#
#######################
sub gologo {
	my ($logorequest) = @_;
	my %logohash = ("kb","http://www.kbiosystems.com/flash%20site/index.html", "Ludwig","http://www.ludwig.ucl.ac.uk/bachem_html/index.htm","UCL","http://www.biochem.ucl.ac.uk/" );
	if ($perlversion eq "MSWin32"){
		my $rc = ShellExecute("open", "$logohash{$logorequest}");
	}
	else {
		
	}
	return ();
}